	TITLE	'CHRFIX HDOS GRAPHICS INSERTION PROGRAM'
********************************************************
*
*	Copyright (c) 1981, 1985, 1989 Lindley Systems
*
*	Program to insert character array data into the
*	graphics driver (GR.DVD), or the PRGR program (PRGR.ABS)
*
*	13-MAY-81 Initial version
*	22-OCT-81 Default to SY1:H19.CHS and SY1:GR.DVD
*	25-OCT-81 Variable length driver file
*
.EXIT	EQU	0A
.SCOUT	EQU	2A
.PRINT	EQU	3A
.READ	EQU	4A
.WRITE	EQU	5A
.CTLC	EQU	41A
.OPENR	EQU	42A
.OPENW	EQU	43A
.OPENU	EQU	44A
.CLOSE	EQU	46A
.POSIT	EQU	47A
.ERROR	EQU	57A
$TYPTX	EQU	31136A
NL	EQU	10
ENL	EQU	138
BELL	EQU	7
*
	ORG	42200A
*
BEGIN	LXI	H,0	GET THE COMMAND LINE POINTER
	DAD	SP	FROM THE TOP OF THE STACK
*
* COPY COMMAND LINE TO BUFFER
*
	LXI	D,BUFF-1
BLOOP	INX	H
	INX	D
	MOV	A,M
	STAX	D
	CPI	0	LOOK FOR ENDING NULL
	JNZ	BLOOP
	XCHG
	INX	H
	MVI	M,ENL
	MVI	A,3	CONTROL C HANDLING
	LXI	H,CCINT
	SCALL	.CTLC
	LXI	H,BUFF
	SCALL	.PRINT
	CALL	$TYPTX
	DB	'CHRFIX - Graphics Insertion Program - 06/16/85',NL
	DB	'Copyright 1981, 1985, 1989 Lindley Systems',NL
	DB	'4257 Berwick Place, Woodbridge VA 22192',NL
	DB	ENL
*
* PARSE THE FILE NAMES
	LXI	H,BUFF
	LXI	D,FNAME1 GET CHARACTER FILE NAME
	CALL	MOVEFN
	LXI	D,FNAME2 GET DRIVER FILE NAME
	CALL	MOVEFN
	CALL	$TYPTX
	DB	'Character input from ',200Q
	LXI	H,FNAME1
	SCALL	.PRINT
	LXI	H,FNAME1
	LXI	D,DFBLK1
	MVI	A,1	FILE 1
	SCALL	.OPENR
	JC	FILEERR
	CALL	$TYPTX
	DB	'Insertion in Driver  ',200Q
	LXI	H,FNAME2
	SCALL	.PRINT
	LXI	D,DFBLK2
	LXI	H,FNAME2
	MVI	A,2	FILE 2
	SCALL	.OPENU
	JC	FILEERR
*  READ IN THE ENTIRE DRIVER FILE
	LXI	D,BUFF
	LXI	B,LENGTH
	MVI	A,2
	SCALL	.READ
	JNC	READOK
	CPI	1
	JNZ	FILEERR
* COMPUTE LENGTH OF DRIVER
	LXI	H,LENGTH
	MOV	A,L
	SUB	C
	MOV	L,A
	MOV	A,H
	SBB	B
	MOV	H,A
	SHLD	LENGTH
READOK	CALL	$TYPTX
	DB	'Driver now in memory',ENL
* LOOK FOR BUFFER START
	LHLD	LENGTH
	LXI	D,BUFF
	XCHG
LOOK	MVI	A,'Q'	BUFFER STARTS AFTER QZ
	CMP	M 
	INX	H
	DCX	D
	JZ	GOTQ
	MOV	A,E
	ORA	D
	JNZ	LOOK
	JMP	NOQZ	Never found 'Q'
GOTQ	MVI	A,'Z'
	CMP	M 
	INX	H
	DCX	D
	JZ	GOTLOC
	MOV	A,E
	ORA	D
	JNZ	LOOK
NOQZ	CALL	$TYPTX
	DB	'"QZ" Missing',ENL
	JMP	FILEERR
GOTLOC	MOV	C,M	LSB DATA LENGTH
	INX	H
	MOV	B,M	MSB DATA LENGTH
	INX	H
	XCHG		D,E POINTS TO DATA AREA
	CALL	$TYPTX
	DB	'Start character transfer',ENL
	MVI	A,1
	SCALL	.READ
	JC	FILEERR
	CALL	$TYPTX
	DB	'Character data in buffer',ENL
	MVI	A,2
	LXI	B,0
	SCALL	.POSIT	SELECT FILE SECTOR
	JC	FILEERR
	CALL	$TYPTX
	DB	'Returning driver to disk',ENL
	LHLD	LENGTH TO WRITE
	MOV	B,H
	MOV	C,L
	LXI	D,BUFF	BUFFER AREA TO WRITE
	MVI	A,2	DRIVER FILE
	SCALL	.WRITE
	JC	FILEERR
	CALL	$TYPTX
	DB	'Character transfer complete',ENL
CCINT	MVI	A,1
	SCALL	.CLOSE
	MVI	A,2
	SCALL	.CLOSE
	MVI	A,0
	SCALL	.EXIT
FILEERR PUSH	PSW	SAVE ERROR CODE
	LXI	H,ERRORA
	SCALL	.PRINT
	POP	PSW
	MVI	H,BELL	BELL WITH MESSAGE
	SCALL	.ERROR
	XRA	A
	SCALL	.EXIT
*
* MOVE FILE NAME FROM COMMAND LINE
* TO FILE NAME DATA AREA
*
*	IN:	FILE NAME IN COMMAND LINE
*	H,L	COMMAND LINE POINTER
*	D,E	FILE NAME POINTER
*
*	OUT:
*
*
MOVEFN	MOV	A,M	GET CHARACTER
	CPI	' '
	JNZ	MCONT	CONTINUE ON NON-BLANK
	INX	H	POINT TO NEXT CHAR
	JMP	MOVEFN	SKIP BLANKS
MCONT	CPI	0	LOOK FOR END OF DATA
	RZ
MLOOP	CPI	0	FILE NAME DELIMITED BY A NULL
	JZ	MXIT
	CPI	' '	OR BY A BLANK
	JZ	MXIT
	STAX	D	SAVE THIS CHARACTER
	INX	H
	INX	D
	MOV	A,M
	JMP	MLOOP
MXIT	XCHG
	MVI	M,0	NAME END FOR OPEN
	INX	H
	MVI	M,ENL	NAME END FOR .PRINT
	XCHG
	RET
LENGTH	DW	14*256
ERRORA	DB	NL,'ERROR -',' '+200Q
DFBLK1	DB	'SY0',0,0,0
FNAME1	DB	'SY0:H19.CHS',0,ENL,0,0,0,0,0,0,0
DFBLK2	DB	'SY0DVD'
FNAME2	DB	'SY0:GR.DVD',0,ENL,0,0,0,0,0,0,0,0
FJ1	DS	1	JUNK
FD1	DS	3	DEVICE
FN1	DS	8	FILE NAME
FX1	DS	7	EXTENSION
FJ2	DS	1	JUNK
FD2	DS	3	DEVICE
FN2	DS	8	FILE NAME
FX2	DS	7	EXTENSION
BUFF	EQU	*	BUFFER AREA AT END
	END	BEGIN
